require 'secs'

eGui = {}
eGui.items = {}

eGui.textbox = class:new()
eGui.textbox.type = 'textbox'
eGui.textbox.name = 'default'
eGui.textbox.text = 'default'
eGui.textbox.x = 0
eGui.textbox.y = 0
eGui.textbox.w = 100
eGui.textbox.h = 25
eGui.textbox.focus = false
eGui.textbox.visible = true
eGui.textbox.exec = function() end

eGui.button = class:new()
eGui.button.type = 'button'
eGui.button.name = 'defualt'
eGui.button.text = 'New Button'
eGui.button.x = 0
eGui.button.y = 0
eGui.button.w = 100
eGui.button.h = 25
eGui.button.focus = false
eGui.button.visible = true
eGui.button.onClick = function() end

function eGui.textbox.create(id, text, x, y, w, h, focus, visible, limit, exec)
	name = eGui.textbox:new()
	name.name = id
	name.text = text
	name.x = x
	name.y = y
	name.w = w
	name.h = h
	name.focus = focus
	name.visible = visible
	name.limit = limit
	name.exec = exec
	table.insert(eGui.items, name)
end

function eGui.button.create(id, text, x, y, w, h, visible, func)
	name = eGui.button:new()
	name.name = id
	name.text = text
	name.x = x
	name.y = y
	name.w = w
	name.h = h
	name.visible = visible
	name.onClick = func
	table.insert(eGui.items, name)
end

function eGui.draw()
	for k,v in ipairs(eGui.items) do
		if v.visible == true then
			if v.type == 'textbox' then
				if v.focus == true then
					love.graphics.rectangle('line',v.x+.5, v.y+.5, v.w, v.h)
					love.graphics.print(v.text..'|', v.x + 5, v.y + 6)
				else
					love.graphics.rectangle('line',v.x+.5, v.y+.5, v.w, v.h)
					love.graphics.print(v.text, v.x + 5, v.y + 6)
				end
			elseif v.type == 'button' then
				love.graphics.rectangle('line',v.x+.5, v.y+.5, v.w, v.h)
				love.graphics.rectangle('line',v.x+2.5, v.y+2.5, v.w-4, v.h-4)
				love.graphics.print(v.text, v.x + 5, v.y + 6)
			end
		end
	end
	love.graphics.setColor(255, 255, 255, 255)
end

function eGui.update(dt)
	-- Does nothing yet.
end

function eGui.mouse(x, y, btn)
	for k,v in ipairs(eGui.items) do
		if btn == 'l' then
			if x > v.x and x < v.x + v.w and y > v.y and y < v.y + v.h then
				if v.type == 'textbox' and v.visible == true then
					v.focus = true
				elseif v.type == 'button' and v.visible == true then
					v.onClick()
				end
			else
				if v.type == 'textbox' then v.focus = false end
			end
		end
	end
end

function eGui.keyboard(key, unicode)
	if key == 'backspace' then
		for k,v in ipairs(eGui.items) do
			if v.type == 'textbox' and v.focus == true then
				v.text = string.sub(v.text, 1, -2)
			end
		end
	elseif key == 'return' then
		for k,v in ipairs(eGui.items) do
			if v.type == 'textbox' and v.focus == true and v.exec then v.exec() end
		end
	elseif key == 'kpenter' then
		for k,v in ipairs(eGui.items) do
			if v.type == 'textbox' and v.focus == true and v.exec then v.exec() end
		end
	else
		for k,v in ipairs(eGui.items) do
			if v.type == 'textbox' and v.focus == true then
				if unicode > 31 and unicode < 127 then
					if string.len(v.text) <= v.limit then
						k = string.char(unicode)
						v.text = v.text..k
					end
				end
			end
		end
	end
end