-- CLIENT

require 'eGui'
require 'whisper'
require 'TSerial'
local socket = require 'socket'

function love.load()
	font = love.graphics.newFont('DejaVuSansMono.ttf')
	love.graphics.setFont(font)
	love.filesystem.setIdentity('whisper')
	if love.filesystem.exists('config.lua') then
		love.filesystem.load('config.lua')()
	else
		config = {}
		config.name = 'NAMELESS'
		config.ip = 'ensayia.no-ip.org'
		config.port = 31325
		config.password = 'password'
		config.firstrun = true
		fh = love.filesystem.newFile('config.lua')
		fh:open('w')
		fh:write('config='..TSerial.pack(config))
		fh:close()
	end
	
	
	txtlog = {}
	love.keyboard.setKeyRepeat(200, 30)
	
	if config.firstrun == true then whisper.msg('This is your first time running Whisper.') whisper.msg('Please configure before connecting.')end
	
	eGui.button.create('connect', 'Connect', 10, 10, 100, 25, true, function() if client then whisper.msg('You are already connected!') else client = whisper.connect() end end)
	eGui.button.create('configure', 'Configure', 115, 10, 100, 25, true, function() whisper.statechange() end)	
	eGui.button.create('s&e', 'Save & Exit', 10, 10, 100, 25, false, function() whisper.savecfg() whisper.statechange() end)
	
	eGui.textbox.create('tbchat', '', 10, 445, 620, 25, true, true, 48, function() whisper.send() end)
	eGui.textbox.create('tbname', config.name, 100, 50, 200, 25, false, false, 16)
	eGui.textbox.create('tbpass', config.password, 100, 80, 200, 25, false, false, 16)
	eGui.textbox.create('tbip', config.ip, 100, 110, 200, 25, false, false, 20)
	eGui.textbox.create('tbport', config.port, 100, 140, 200, 25, false, false, 5)
	
end

function love.update(dt)
	eGui.update(dt)
	if client then
		whisper.receive()
	end
end

function love.draw()
	eGui.draw()
	if whisper.state == 'normal' then
		love.graphics.rectangle('line', 10.5, 42.5, 484, 395)
		love.graphics.rectangle('line', 502.5, 42.5, 128, 395)
		for k,v in ipairs(txtlog) do
			love.graphics.print(v, 15, k*15 + 30)
		end
		love.graphics.print('Clients:', 502, 20)
		for k, v in ipairs(clientlist) do
			love.graphics.print(v, 506, k*15 + 30)
		end
	elseif whisper.state == 'configure' then
		love.graphics.print('Name: ', 10, 55)
		love.graphics.print('Password: ', 10, 85)
		love.graphics.print('This does nothing yet', 305, 85)
		love.graphics.print('Server IP: ', 10, 115)
		love.graphics.print('Defualt: ensayia.no-ip.org', 305, 115)
		love.graphics.print('Server Port: ', 10, 145)
		love.graphics.print('Defualt: 31325', 305, 145)
	end
end

function love.keypressed(key, unicode)
	eGui.keyboard(key, unicode)
end

function love.quit()
	if client then
		client:send('%S04\n')
	end
end

function love.mousepressed(x, y, btn)
	eGui.mouse(x, y, btn)
end

-- Command Prefixes
-- %C01 chat message
-- %C02 client list