whisper = {}
whisper.state = 'normal'
clientlist = {}

function whisper.connect()	
	local client = socket.tcp()
	local success = client:connect(config.ip, config.port)
	if not success then 
		whisper.msg('Failed to connect to server, check your configuration') 
		whisper.msg('and verify IP address.')
	end
	if config.firstrun == true then
		config.firstrun = false
		fh = love.filesystem.newFile('config.lua')
		fh:open('w')
		fh:write('config = '..TSerial.pack(config))
		fh:close()
	end	
	client:settimeout(0)
	client:send('%S02'..config.name..'\n')
	client:send('%S03'..config.password..'\n')
	if success then return client else return nil end
end

function whisper.savecfg()
	local old = config.name
	for k,v in ipairs(eGui.items) do
		if v.name == 'tbname' then config.name = v.text end
		if v.name == 'tbpass' then config.password = v.text end
		if v.name == 'tbip' then config.ip = tostring(v.text) end
		if v.name == 'tbport' then config.port = v.text end
	end
	if client then 
		if old ~= config.name then 
			client:send('%S02'..config.name..'\n')
		end
	end
	fh = love.filesystem.newFile('config.lua')
	fh:open('w')
	fh:write('config = '..TSerial.pack(config))
	fh:close()
end

function whisper.send()
	for k,v in ipairs(eGui.items) do
		if v.type == 'textbox' and v.focus == true and v.visible == true then
			if client then
				client:send('%S01'..v.text..'\n')
			else
				whisper.msg('You are not connected. No one hears you')
			end
			v.text = ''
		end
	end
end
			

function whisper.receive()
	local msg = client:receive()
	if msg then
		local code = string.sub(msg, 1, 4)
		local newmsg = string.sub (msg, 5)
		if code == '%C01' then
			whisper.msg(newmsg)
		elseif code == '%C02' then
			clientlist = TSerial.unpack(newmsg)
		end
	end		
end

function whisper.msg(msg)
	table.insert(txtlog, msg)
	if #txtlog > 26 then 
		repeat table.remove(txtlog, 1) until #txtlog == 26
	end
end

function whisper.statechange()
	if whisper.state == 'normal' then
		whisper.state = 'configure'
		for k,v in ipairs(eGui.items) do
			if v.name == 'connect' then v.visible = false end
			if v.name == 'configure' then v.visible = false end
			if v.name == 'tbchat' then v.visible = false v.focus = false end
			
			if v.name == 's&e' then v.visible = true end
			if v.name == 'tbname' then v.visible = true v.text = config.name end
			if v.name == 'tbpass' then v.visible = true v.text = config.password end
			if v.name == 'tbip' then v.visible = true v.text = config.ip end
			if v.name == 'tbport' then v.visible = true v.text = config.port end
		end
	elseif whisper.state == 'configure' then
		whisper.state = 'normal'
		for k,v in ipairs(eGui.items) do
			if v.name == 'connect' then v.visible = true end
			if v.name == 'configure' then v.visible = true end
			if v.name == 'tbchat' then v.visible = true end
			
			if v.name == 's&e' then v.visible = false end
			if v.name == 'tbname' then v.visible = false end
			if v.name == 'tbpass' then v.visible = false end
			if v.name == 'tbip' then v.visible = false end
			if v.name == 'tbport' then v.visible = false end
		end
	end		
end

-- Command Prefixes
-- %C01 chat message
-- %C02 client list